<template>
    <div>
        <!-- SEÑALES -->  
        <h4 class="text-orange" style="margin: 3rem 0 2rem">SEÑALES</h4>
        <el-row style="margin: 0.7rem 0 1rem">
            <div style="display: flex; align-items: center; justify-content: space-between;  width: 40%;"  v-if="conditionalShow">
                <!-- check -->
                <el-checkbox :indeterminate="isIndeterminate" v-model="check" @change="$emit('handleCheckAllChange', {check, position})" v-if="isHaveAllSignals" border>Todas las señales</el-checkbox>
                <el-button @click="isOpen = true">Seleccionar</el-button>
            </div>
            <!-- Modal -->       
            <el-dialog
                :visible.sync="isOpen"
                width="40%"
                center :show-close="false"
                :close-on-press-escape="false"
                :close-on-click-modal="closeOnClickModal"
                custom-class="dialog-orange">
                <div style="margin: 0; line-height: 40px;" prop="checkedSignals">
                <el-checkbox-group v-model="checkedModal" @change="$emit('handleCheckedSignalsChange', {checkedModal, position})" class="text-center" style="margin-left: 3rem;">
                    <el-checkbox v-for="signal in signalsTrans" :label="signal.name" :key="signal.name" :disabled="signal.isDisabled" v-model="checkedModal" style="width: 30%; margin: 0" class="text-start" >{{signal.name}}</el-checkbox>
                </el-checkbox-group>
                </div>
                <div style="display: flex; align-items: center; margin-top: 20px" :class="[ btnIsDisabled == true ? 'spaceBetween' : 'flexEnd']">
                    <p v-show="btnIsDisabled" style="color: #fc0000; font-size: 12px;">* Debe seleccionar al menos una señal</p>
                    <div style="text-align: right;">
                        <el-button @click="isOpen = false" class="text-orange border-orange" :disabled="btnIsDisabled">CANCELAR</el-button>
                        <el-button @click="isOpen = false" type="primary" :disabled="btnIsDisabled">ACEPTAR</el-button>
                    </div>
                   
                </div>
            </el-dialog>
        </el-row>
        <div style="margin: 0 0 4rem; line-height: 40px;" prop="checkedSignals">
            <div class="bg-gray" style="display: table; height: 8rem; width:100%; padding:10px 7px 0">
                <!-- <p>{{checkedModal}}</p> -->
                <el-col v-for="(item, j) in checkedModal" :key="j"
                class="bg-white" style="margin:7px; padding:0 5px; width:9rem">{{item}} </el-col>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    name: 'componentSignal',
    props: {
        isIndeterminate: {
            type: Boolean
        },
        checkAll: {
            type: Boolean
        },
        // handleCheckAllChange: {
        //     type: Function
        // },
        // handleCheckedSignalsChange: {
        //     type: Function
        // },
        checkedSignals: {
            type: Array
        },
        signals: {
            type: Array
        },
        signalModal: {
            type: Boolean
        },
        conditionalShow: {
            type: Boolean
        },
        signalsTrans: {
            type: Array
        },
        isHaveAllSignals: {
            type: Boolean
        },
        closeOnClickModal: {
            required: true,
            type: Boolean
        },
        position: {
            required: true,
            type: Number
        }
    },
    data() {
        return {
            isOpen: this.signalModal,
            checkedModal: this.checkedSignals,
            checked: this.signalsTrans,
            check: this.checkAll,
            // check: false,
            isTrue: true,
            btnIsDisabled: false
        }
    },
    watch: {
        checkedSignals(val) {
            this.checked = this.checkedModal =  val
            this.btnIsDisabled = val.length == 0 ? true : false
        },
        checkedModal(val) {
            this.btnIsDisabled = val.length == 0 ? true : false
        },
    },
    created() {
        if(this.checkedSignals) {
            this.btnIsDisabled = this.checkedSignals.length == 0 ? true : false
        }
    }
}
</script>

<style scope>
    .spaceBetween {
       justify-content: space-between;
    }
    .flexEnd {
       justify-content: flex-end;
    }
</style>